<?php

namespace App\Exports\V2\RoadPatrol\RoadPatrolTable;

use Illuminate\Contracts\View\View;
use Maatwebsite\Excel\Concerns\FromView;
use App\Models\RoadPatrolProject;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Events\AfterSheet;
use Maatwebsite\Excel\Concerns\WithEvents;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Concerns\WithDrawings;
use PhpOffice\PhpSpreadsheet\Worksheet\Drawing;
use Carbon\Carbon;

class Provinces implements FromView, ShouldAutoSize, WithEvents, WithDrawings
{
    public function __construct($from_date, $date_to)
    {
        $this->from_date = $from_date;
        $this->date_to = $date_to;
    }

    public function view(): View
    {
        $from_date = $this->from_date ?? Date('Y-m-d'). " 00:00:00";
        $date_to = $this->date_to ?? Date('Y-m-d')." 23:59:59";

        $data = RoadPatrolProject::provincePatrolData($from_date, $date_to);

        return view('excel.V2.RoadPatrol.RoadPatrolTable.Province', [
            'data' => $data,
            'fromFa' => $from_date,
            'toFa' => $date_to
        ]);
    }
  
    /**
     * @return array
    */
    public function registerEvents(): array
    {
        return [
            AfterSheet::class    => function (AfterSheet $event) {
                $event->sheet->getDelegate()->setRightToLeft(true);
            }
        ];
    }

    
    public function drawings()
    {
        $drawing = new Drawing();
        $drawing->setName('Logo');
        $drawing->setDescription('This is my logo');
        $drawing->setPath(public_path('/dist/logo.png'));
        $drawing->setWidth(50);
        $drawing->setHeight(50);
        $drawing->setOffsetX(5);
        $drawing->setOffsetY(5);
        $drawing->setCoordinates('A1');
        
        $drawing2 = new Drawing();
        $drawing2->setName('Logo');
        $drawing2->setDescription('This is my logo');
        $drawing2->setPath(public_path('/dist/141icon.png'));
        $drawing2->setWidth(50);
        $drawing2->setHeight(50);
        $drawing2->setOffsetX(5);
        $drawing2->setOffsetY(5);
        $drawing2->setCoordinates('H1');
        return [$drawing, $drawing2];
    }
}
